
Name:      qubes-mgmt-salt-dom0-virtual-machines
Version:   4.0.17
Release:   1%{?dist}
Summary:   Downloads, installs and configures template as well as creating and configuring virtual-machine AppVM's.
License:   GPL 2.0
URL:	   http://www.qubes-os.org/

Group:     System administration tools
BuildArch: noarch
Requires:  qubes-mgmt-salt
Requires:  qubes-mgmt-salt-dom0
Requires:  qubes-core-admin-addon-whonix
# do not require qubes-core-dom0 directly, but if installed, make sure it's the
# right version
Conflicts: qubes-core-dom0 < 4.0.35

Source0: %{name}-%{version}.tar.gz

%description
Downloads, installs and configures template as well as creating and configuring virtual-machine AppVM's.
Uses pillar data to define default VM names and configuration details.

%prep
%setup -q

%build

%install
make install DESTDIR=%{buildroot} LIBDIR=%{_libdir} BINDIR=%{_bindir} SBINDIR=%{_sbindir} SYSCONFDIR=%{_sysconfdir}

%pre

if [ $1 -ge 2 ] && ! [ -e /srv/formulas/base/virtual-machines-formula/qvm/default-mgmt-dvm.sls ]; then
    touch /var/run/%{name}-default-mgmt-dvm-firstinstall
fi

%post
# Enable Pillar States
qubesctl top.enable qvm pillar=true -l quiet --out quiet > /dev/null || true

# Migrate enabled tops from dom0 to base environment
for top in sys-net sys-firewall sys-whonix anon-whonix personal work untrusted vault sys-usb sys-net-with-usb; do
    if [ -h /srv/salt/_tops/dom0/qvm.$top.top ]; then
        rm -f /srv/salt/_tops/dom0/qvm.$top.top
        qubesctl top.enable qvm.$top -l quiet --out quiet > /dev/null || true
    fi
done

if [ -r /srv/pillar/_tops/dom0/qvm.top ]; then
    rm -f /srv/pillar/_tops/dom0/qvm.top
fi

%posttrans

if [ -e /var/run/%{name}-default-mgmt-dvm-firstinstall ]; then
    # create default-mgmt-dvm on update, see QSB#45
    qubesctl state.sls qvm.default-mgmt-dvm
    rm /var/run/%{name}-default-mgmt-dvm-firstinstall
fi

%files
%defattr(-,root,root)
%doc LICENSE README.md
%attr(750, root, root) %dir /srv/formulas/base/virtual-machines-formula
/srv/formulas/base/virtual-machines-formula/README.md
/srv/formulas/base/virtual-machines-formula/LICENSE
/srv/formulas/base/virtual-machines-formula/qvm/anon-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/anon-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/default-dispvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/default-dispvm.top
/srv/formulas/base/virtual-machines-formula/qvm/default-mgmt-dvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/hide-usb-from-dom0.sls
/srv/formulas/base/virtual-machines-formula/qvm/personal.sls
/srv/formulas/base/virtual-machines-formula/qvm/personal.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-firewall.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-firewall.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-net.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-net.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-usb.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-usb.top
/srv/formulas/base/virtual-machines-formula/qvm/sys-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/sys-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/template-debian-7.sls
/srv/formulas/base/virtual-machines-formula/qvm/template-debian-8.sls
/srv/formulas/base/virtual-machines-formula/qvm/template-fedora-21-minimal.sls
/srv/formulas/base/virtual-machines-formula/qvm/template-fedora-21.sls
/srv/formulas/base/virtual-machines-formula/qvm/template.jinja
/srv/formulas/base/virtual-machines-formula/qvm/template-whonix-gw.sls
/srv/formulas/base/virtual-machines-formula/qvm/template-whonix-ws.sls
/srv/formulas/base/virtual-machines-formula/qvm/untrusted.sls
/srv/formulas/base/virtual-machines-formula/qvm/untrusted.top
/srv/formulas/base/virtual-machines-formula/qvm/updates-via-whonix.sls
/srv/formulas/base/virtual-machines-formula/qvm/updates-via-whonix.top
/srv/formulas/base/virtual-machines-formula/qvm/usb-keyboard.sls
/srv/formulas/base/virtual-machines-formula/qvm/usb-keyboard.top
/srv/formulas/base/virtual-machines-formula/qvm/vault.sls
/srv/formulas/base/virtual-machines-formula/qvm/vault.top
/srv/formulas/base/virtual-machines-formula/qvm/whonix.jinja
/srv/formulas/base/virtual-machines-formula/qvm/whonix-ws-dvm.sls
/srv/formulas/base/virtual-machines-formula/qvm/work.sls
/srv/formulas/base/virtual-machines-formula/qvm/work.top

%attr(750, root, root) %dir /srv/pillar/base/qvm
%config(noreplace) /srv/pillar/base/qvm/init.sls
%config(noreplace) /srv/pillar/base/qvm/sys-net-as-usbvm.sls
%config(noreplace) /srv/pillar/base/qvm/sys-net-as-usbvm.top
%config(noreplace) /srv/pillar/base/qvm/whonix-testing.sls
%config(noreplace) /srv/pillar/base/qvm/whonix-testing.top
/srv/pillar/base/qvm/init.top

%config(noreplace) /etc/salt/minion.d/formula-virtual-machines.conf

%changelog
* Sat Sep 11 2021 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-mgmt-salt-dom0-virtual-machines.git

* Sat Sep 11 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 90f924f
- version 4.0.17

* Sat Sep 11 2021 Patrick Schleizer <adrelanos@whonix.org> - 9b35982
- Whonix 16

* Mon Jun 24 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c01091f
- version 4.0.16

* Mon Jun 24 2019 Patrick Schleizer <adrelanos@riseup.net> - da6cde1
- Whonix 15

* Mon Jun 24 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3762f85
- Remove separate sys-net-with-usb state

* Mon Dec 03 2018 Simon Gaiser <simon@invisiblethingslab.com> - 4476968
- version 4.0.15

* Mon Dec 03 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ac176c2
- rpm: run qvm.default-mgmt-dvm state on update

* Mon Dec 03 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 44cc1b9
- Add default-mgmt-dvm VM

* Fri Nov 02 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - fa2d298
- version 4.0.14

* Fri Nov 02 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6bd3643
- Use default template for qvm.default-dispvm state

* Wed Aug 08 2018 Patrick Schleizer <adrelanos@riseup.net> - d685813
- comment

* Fri Jul 27 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f49923f
- version 4.0.13

* Mon Jul 23 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d0c3c60
- whonix: fix versioned whonix-ws-dvm

* Mon Jul 23 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 07337e6
- whonix: Add pillar file for easily enabling templates testing repository

* Fri Jul 13 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 527ab0a
- Update for fedora-28 default template

* Mon Jun 18 2018 Andrew David Wong <adw@andrewdavidwong.com> - 189a2d8
- Update README filename in FORMULA.dom0

* Sun Jun 17 2018 Andrew David Wong <adw@andrewdavidwong.com> - cac63b5
- Update README filename in rpm_spec/*.spec.in

* Sat Jun 16 2018 Andrew David Wong <adw@andrewdavidwong.com> - 348c261
- Move README contents to official documentation

* Tue May 15 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9aa2c3a
- version 4.0.12

* Tue May 15 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 29ea2dd
- Fix anon-whonix.default-dispvm to use versioned name

* Mon May 14 2018 viq <vicviq@gmail.com> - 3952aae
- Remove excessive jinja whitespace control.

* Mon May 14 2018 viq <vicviq@gmail.com> - fd4d2e8
- Fix 'features'

* Sun May 13 2018 viq <vicviq@gmail.com> - d2bfbf3
- Adjust import statement.

* Mon May 07 2018 viq <vicviq@gmail.com> - 4dcf91e
- Fix typo in filename

* Mon May 07 2018 viq <vicviq@gmail.com> - e441027
- Add missing file to RPM spec

* Mon May 07 2018 viq <vicviq@gmail.com> - 0669933
- Update to whonix 14 using versioned templates.

* Mon May 07 2018 Patrick Schleizer <adrelanos@riseup.net> - b14055b
- Requires:  qubes-core-admin-addon-whonix

* Mon May 07 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f5db38b
- travis: update to R4.0

* Tue Apr 03 2018 Frédéric Pierret <frederic.epitre@orange.fr> - d237ac1
- spec.in: add changelog placeholder

* Sun Apr 01 2018 Frédéric Pierret <frederic.epitre@orange.fr> - e124f89
- Create .spec.in and Source0

* Sun Mar 04 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 00d552e
- version 4.0.11

* Sun Mar 04 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f39ee81
- add whonix-{ws,gw} feature to whonix-{ws,gw} templates

* Thu Feb 01 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8522468
- Create qvm.usb-keyboard state

* Thu Feb 01 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c21c872
- Support pillar qvm:sys-usb:name = sys-net

* Mon Jan 22 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e35121c
- version 4.0.10

* Mon Jan 22 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 00da706
- Update default dispvm base VM to fedora-25-dvm

* Fri Jan 19 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 545eabb
- version 4.0.9

* Fri Jan 19 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8394a9c
- Set PCI-having VMs explicitly to HVM

* Sat Dec 23 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5f74665
- version 4.0.8

* Fri Dec 22 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ca27a33
- Use tag instead of direct name for updatevm setting

* Tue Nov 21 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 41ce3ad
- version 4.0.7

* Mon Nov 20 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 71fe4e1
- Explicitly disable meminfo-writer for PCI device-having VMs

* Sun Oct 08 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 454a4b1
- version 4.0.6

* Sun Oct 08 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4281156
- Setup appmenus for whonix-ws-dvm as Disposable VM

* Sat Oct 07 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a0cbb48
- Add state to route all updates through Whonix

* Sat Oct 07 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d17f665
- Switch sys-net and sys-usb back to HVM

* Thu Sep 14 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3998dec
- version 4.0.5

* Thu Sep 14 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6a1cfab
- Create whonix-ws-dvm for Whonix Disposable VMs

* Thu Sep 14 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 977362e
- Adjust Whonix setup for Qubes 4.0

* Fri Aug 11 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - fe14cf8
- version 4.0.4

